using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;
using System.IO;
using System.Globalization;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;


namespace NeuroX
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormEditor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu menuGlowne;
		private System.Windows.Forms.MenuItem menuItemHelpAbout;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemEditor;
		private System.Windows.Forms.ToolBarButton tbbNewNeuron;
		private System.Windows.Forms.ToolBarButton tbbNewLine;
		private System.Windows.Forms.ToolBarButton tbbSelectNeuron;
		private System.Windows.Forms.MenuItem menuItemEditorNN;
		private System.Windows.Forms.MenuItem menuItemEditorSN;
		private System.Windows.Forms.MenuItem menuItemEditorNL;
		private System.Windows.Forms.ToolBar tbMain;
		private System.Windows.Forms.MenuItem NetworkOneStep;
		private System.Windows.Forms.MenuItem menuItemNetwork;
		private System.Windows.Forms.MenuItem menuItemNetworkSave;
		private System.Windows.Forms.SaveFileDialog saveNetworkDialog;
		private System.Windows.Forms.MenuItem menuItemNetworkNew;
		private System.Windows.Forms.MenuItem menuItemNetworkOpen;
		private System.Windows.Forms.OpenFileDialog openNetworkDialog;
		private System.Windows.Forms.MenuItem NetworkReset;
		private System.Windows.Forms.Panel panelNetEditor;
		private System.Windows.Forms.MenuItem menuItemNetworkOptimize;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItemHelpHelp;
		public Random r;
		public FormEditor()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			r = new Random(601);
			myPenLink = new Pen(Color.Black, 2);
			initializeNetwork();
			//	panelNetEditor.ClientSize  = new Size(1000,1000);
			panelNetEditor.AutoScroll = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.menuGlowne = new System.Windows.Forms.MainMenu();
			this.menuItemNetwork = new System.Windows.Forms.MenuItem();
			this.menuItemNetworkNew = new System.Windows.Forms.MenuItem();
			this.menuItemNetworkOpen = new System.Windows.Forms.MenuItem();
			this.menuItemNetworkSave = new System.Windows.Forms.MenuItem();
			this.menuItemEditor = new System.Windows.Forms.MenuItem();
			this.menuItemEditorSN = new System.Windows.Forms.MenuItem();
			this.menuItemEditorNN = new System.Windows.Forms.MenuItem();
			this.menuItemEditorNL = new System.Windows.Forms.MenuItem();
			this.NetworkOneStep = new System.Windows.Forms.MenuItem();
			this.NetworkReset = new System.Windows.Forms.MenuItem();
			this.menuItemNetworkOptimize = new System.Windows.Forms.MenuItem();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemHelpAbout = new System.Windows.Forms.MenuItem();
			this.tbMain = new System.Windows.Forms.ToolBar();
			this.tbbSelectNeuron = new System.Windows.Forms.ToolBarButton();
			this.tbbNewNeuron = new System.Windows.Forms.ToolBarButton();
			this.tbbNewLine = new System.Windows.Forms.ToolBarButton();
			this.saveNetworkDialog = new System.Windows.Forms.SaveFileDialog();
			this.openNetworkDialog = new System.Windows.Forms.OpenFileDialog();
			this.panelNetEditor = new System.Windows.Forms.Panel();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItemHelpHelp = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// menuGlowne
			// 
			this.menuGlowne.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItemNetwork,
																					   this.menuItemEditor,
																					   this.menuItem2,
																					   this.menuItemHelp});
			// 
			// menuItemNetwork
			// 
			this.menuItemNetwork.Index = 0;
			this.menuItemNetwork.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.menuItemNetworkNew,
																							this.menuItemNetworkOpen,
																							this.menuItemNetworkSave});
			this.menuItemNetwork.Text = "&Network";
			// 
			// menuItemNetworkNew
			// 
			this.menuItemNetworkNew.Index = 0;
			this.menuItemNetworkNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.menuItemNetworkNew.Text = "&New";
			this.menuItemNetworkNew.Click += new System.EventHandler(this.menuItemNetworkNew_Click);
			// 
			// menuItemNetworkOpen
			// 
			this.menuItemNetworkOpen.Index = 1;
			this.menuItemNetworkOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.menuItemNetworkOpen.Text = "&Open";
			this.menuItemNetworkOpen.Click += new System.EventHandler(this.menuItemNetworkOpen_Click);
			// 
			// menuItemNetworkSave
			// 
			this.menuItemNetworkSave.Index = 2;
			this.menuItemNetworkSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.menuItemNetworkSave.Text = "&Save";
			this.menuItemNetworkSave.Click += new System.EventHandler(this.menuItemNetworkSave_Click);
			// 
			// menuItemEditor
			// 
			this.menuItemEditor.Index = 1;
			this.menuItemEditor.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						   this.menuItem1,
																						   this.menuItemEditorSN});
			this.menuItemEditor.Text = "&Editor";
			// 
			// menuItemEditorSN
			// 
			this.menuItemEditorSN.Index = 1;
			this.menuItemEditorSN.RadioCheck = true;
			this.menuItemEditorSN.Text = "&Select neuron";
			this.menuItemEditorSN.Click += new System.EventHandler(this.menuItemEditorSN_Click);
			// 
			// menuItemEditorNN
			// 
			this.menuItemEditorNN.Index = 0;
			this.menuItemEditorNN.RadioCheck = true;
			this.menuItemEditorNN.Text = "&New neuron";
			this.menuItemEditorNN.Click += new System.EventHandler(this.menuItemEditorNN_Click);
			// 
			// menuItemEditorNL
			// 
			this.menuItemEditorNL.Index = 1;
			this.menuItemEditorNL.RadioCheck = true;
			this.menuItemEditorNL.Text = "New &connect";
			this.menuItemEditorNL.Click += new System.EventHandler(this.menuItemEditorNL_Click);
			// 
			// NetworkOneStep
			// 
			this.NetworkOneStep.Index = 1;
			this.NetworkOneStep.Shortcut = System.Windows.Forms.Shortcut.CtrlE;
			this.NetworkOneStep.Text = "&Iterate network";
			this.NetworkOneStep.Click += new System.EventHandler(this.NetworkOneStep_Click);
			// 
			// NetworkReset
			// 
			this.NetworkReset.Index = 2;
			this.NetworkReset.Shortcut = System.Windows.Forms.Shortcut.CtrlR;
			this.NetworkReset.Text = "&Reset network";
			this.NetworkReset.Click += new System.EventHandler(this.NetworkReset_Click);
			// 
			// menuItemNetworkOptimize
			// 
			this.menuItemNetworkOptimize.Index = 0;
			this.menuItemNetworkOptimize.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.menuItemNetworkOptimize.Text = "&Optimization";
			this.menuItemNetworkOptimize.Click += new System.EventHandler(this.menuItemNetworkOptimize_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 3;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemHelpHelp,
																						 this.menuItemHelpAbout});
			this.menuItemHelp.Text = "&Help";
			// 
			// menuItemHelpAbout
			// 
			this.menuItemHelpAbout.Index = 1;
			this.menuItemHelpAbout.Text = "&About";
			this.menuItemHelpAbout.Click += new System.EventHandler(this.menuItemHelpAbout_Click);
			// 
			// tbMain
			// 
			this.tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					  this.tbbSelectNeuron,
																					  this.tbbNewNeuron,
																					  this.tbbNewLine});
			this.tbMain.Location = new System.Drawing.Point(0, 0);
			this.tbMain.Name = "tbMain";
			this.tbMain.ShowToolTips = true;
			this.tbMain.Size = new System.Drawing.Size(824, 42);
			this.tbMain.TabIndex = 3;
			this.tbMain.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbMain_ButtonClick);
			// 
			// tbbSelectNeuron
			// 
			this.tbbSelectNeuron.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tbbSelectNeuron.Text = "Select neuron";
			this.tbbSelectNeuron.ToolTipText = "Selects Neuron to move it";
			// 
			// tbbNewNeuron
			// 
			this.tbbNewNeuron.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tbbNewNeuron.Text = "New neuron";
			this.tbbNewNeuron.ToolTipText = "Create new Neuron";
			// 
			// tbbNewLine
			// 
			this.tbbNewLine.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.tbbNewLine.Text = "New connect";
			this.tbbNewLine.ToolTipText = "Connect two neurons";
			// 
			// saveNetworkDialog
			// 
			this.saveNetworkDialog.FileName = "doc1";
			this.saveNetworkDialog.Filter = "Neural networks files|*.nnt";
			// 
			// openNetworkDialog
			// 
			this.openNetworkDialog.Filter = "Neural networks files|*.nnt";
			// 
			// panelNetEditor
			// 
			this.panelNetEditor.AutoScroll = true;
			this.panelNetEditor.AutoScrollMargin = new System.Drawing.Size(5, 5);
			this.panelNetEditor.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelNetEditor.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelNetEditor.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.panelNetEditor.Location = new System.Drawing.Point(0, 42);
			this.panelNetEditor.Name = "panelNetEditor";
			this.panelNetEditor.Size = new System.Drawing.Size(824, 407);
			this.panelNetEditor.TabIndex = 4;
			this.panelNetEditor.Resize += new System.EventHandler(this.panelNetEditor_Resize);
			this.panelNetEditor.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panelNetEditor_MouseUp);
			this.panelNetEditor.Paint += new System.Windows.Forms.PaintEventHandler(this.panelNetEditor_Paint);
			this.panelNetEditor.DoubleClick += new System.EventHandler(this.panelNetEditor_DoubleClick);
			this.panelNetEditor.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panelNetEditor_MouseMove);
			this.panelNetEditor.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panelNetEditor_MouseDown);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemEditorNN,
																					  this.menuItemEditorNL});
			this.menuItem1.Text = "&Create";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemNetworkOptimize,
																					  this.NetworkOneStep,
																					  this.NetworkReset});
			this.menuItem2.Text = "&Options";
			// 
			// menuItemHelpHelp
			// 
			this.menuItemHelpHelp.Index = 0;
			this.menuItemHelpHelp.Text = "&Help";
			this.menuItemHelpHelp.Click += new System.EventHandler(this.menuItemHelpHelp_Click);
			// 
			// FormEditor
			// 
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(824, 449);
			this.Controls.Add(this.panelNetEditor);
			this.Controls.Add(this.tbMain);
			this.Menu = this.menuGlowne;
			this.Name = "FormEditor";
			this.Text = "Brain optimizer for Framsticks ver. 1.0";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormEditor());
		}
		
		private void menuItemHelpAbout_Click(object sender, System.EventArgs e)
		{
			FormAbout fa = new FormAbout();
			fa.ShowDialog(this);
			
		}
		Pen myPenLink;
		protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
		{
			panelNetEditor.Invalidate();
		}

		protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
		{
	
		}

		/// <summary>
		/// // actual moving neuron in neurons
		/// </summary>
		private int actNeuron;

		protected override void OnMouseMove(System.Windows.Forms.MouseEventArgs e)
		{
	
		}

		/// <summary>
		/// // if the trangle is being moved
		/// </summary>
		private bool bMoving = false;
		private int nXbefore;
		public int nYbefore;

		protected override void OnMouseUp(System.Windows.Forms.MouseEventArgs e)
		{
			//	panelNetEditor.Size = new Size(1000,1000);
			//	panelNetEditor.ClientSize  = new Size(1000,1000);
			//	panelNetEditor.AutoScroll = true;
		
		}

		/// <summary>
		/// array list of neurons
		/// </summary>
		public Hashtable neurons;

		protected override void OnDoubleClick(System.EventArgs e)
		{
		}
	
		/// <summary>
		/// // the point where mouse have been recently clicked
		/// </summary>
		public Point mousePoint;

		// select neuron
		private void menuItemEditorSN_Click(object sender, System.EventArgs e)
		{
			if (menuItemEditorSN.Checked == false)
			{
				menuItemEditorSN.Checked = true;
				menuItemEditorNL.Checked = false;
				menuItemEditorNN.Checked = false;
				tbbSelectNeuron.Pushed = true;
				tbbNewNeuron.Pushed = false;
				tbbNewLine.Pushed = false;
			}

		}

		// new neuron
		private void menuItemEditorNN_Click(object sender, System.EventArgs e)
		{
			if (menuItemEditorNN.Checked == false)
			{
				menuItemEditorNN.Checked = true;
				menuItemEditorNL.Checked = false;
				menuItemEditorSN.Checked = false;
				tbbSelectNeuron.Pushed = false;
				tbbNewNeuron.Pushed = true;
				tbbNewLine.Pushed = false;
			}
		
		}

		// new link
		private void menuItemEditorNL_Click(object sender, System.EventArgs e)
		{
			if (menuItemEditorNL.Checked == false)
			{
				menuItemEditorNL.Checked = true;
				menuItemEditorSN.Checked = false;
				menuItemEditorNN.Checked = false;
				tbbSelectNeuron.Pushed = false;
				tbbNewNeuron.Pushed = false;
				tbbNewLine.Pushed = true;
			}		
		}


		private void tbMain_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == tbbNewNeuron) 
			{
				menuItemEditorSN.Checked = false;
				menuItemEditorNL.Checked = false;
				menuItemEditorNN.Checked = true;
				tbbSelectNeuron.Pushed = false;
				tbbNewNeuron.Pushed = true;
				tbbNewLine.Pushed = false;
			}
			else if (e.Button == tbbNewLine) 
			{
				menuItemEditorSN.Checked = false;
				menuItemEditorNL.Checked = true;
				menuItemEditorNN.Checked = false;
				tbbSelectNeuron.Pushed = false;
				tbbNewNeuron.Pushed = false;
				tbbNewLine.Pushed = true;
			}
			else if (e.Button == tbbSelectNeuron) 
			{
				menuItemEditorSN.Checked = true;
				menuItemEditorNL.Checked = false;
				menuItemEditorNN.Checked = false;
				tbbSelectNeuron.Pushed = true;
				tbbNewNeuron.Pushed = false;
				tbbNewLine.Pushed = false;
			}
		}

		public bool bFirstNeuronLink;
		/// <summary>
		/// id of first nbeuron
		/// </summary>
		public int firstNeuronLink;
		/// <summary>
		/// id of second neuron in a link
		/// </summary>
		public int secondNeuronLink;
		/// <summary>
		/// // next unical ID
		/// </summary>
		private int nextID;
		public void networkStep()
		{
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				((Neuron)myEnumerator.Value).calculateInput(neurons);
			}
			myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				((Neuron)myEnumerator.Value).CalculateOutput();
			}
			Invalidate();

		}
		private void NetworkOneStep_Click(object sender, System.EventArgs e)
		{
			networkStep();
		}
		private int getNumberOfNeuron(int nKey)
		{
			int n =0 ;
			for (int i=0;i<=nextID-1;i++)
			{
				if (neurons[i]!= null)
				{
					if (i==nKey) return n;
					n++;
				}
				//else MessageBox.Show("Jednak!!");
			}
			return -1; // it is impossible (teoretically)
	/*		IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{

			}*/

			
		}
		private void menuItemNetworkSave_Click(object sender, System.EventArgs e)
		{
			if( this.saveNetworkDialog.ShowDialog(this) != DialogResult.OK ) 
				return;
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			string fileName = this.saveNetworkDialog.FileName;
			StreamWriter sr = File.CreateText(fileName);
//			while ( myEnumerator.MoveNext() )
			for (int i=0; i<= nextID-1; i++)
			{
				if (neurons[i]!= null)
				{
					Object neuron = neurons[i];
					sr.Write("n:d=\"");
					if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronDifferentiate")==0) 
					{				
						sr.Write("D:prevInput={0},",Convert.ToString(((NeuronDifferentiate)neuron).prevInput,new CultureInfo("en-GB")));
					}
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronConstant")==0) 
					{
						sr.Write("*:const={0},",1);
					} 
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronRandom")==0) 
					{
						sr.Write("Rnd:");
					}
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSigmoidN")==0) 
					{
						sr.Write("N:sigmo={0},force={1},inertia={2},",
							Convert.ToString(((NeuronSigmoidN)neuron).sigmo,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronSigmoidN)neuron).force,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronSigmoidN)neuron).inertia,new CultureInfo("en-GB")));

					}
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSigmoidNu")==0) 
					{
						sr.Write("Nu:sigmo={0},force={1},inertia={2},",
							Convert.ToString(((NeuronSigmoidNu)neuron).sigmo,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronSigmoidNu)neuron).force,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronSigmoidNu)neuron).inertia,new CultureInfo("en-GB")));
					}
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSinusoid")==0) 
					{
						sr.Write("Sin:f={0},t={1},",
							Convert.ToString(((NeuronSinusoid)neuron).f0,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronSinusoid)neuron).t,new CultureInfo("en-GB")));
					}
					else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronThreshold")==0) 
					{
						sr.Write("Thr:t={2},lo={1},hi={0},",
							Convert.ToString(((NeuronThreshold)neuron).hi,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronThreshold)neuron).lo,new CultureInfo("en-GB")),
							Convert.ToString(((NeuronThreshold)neuron).t,new CultureInfo("en-GB")));
					}
					sr.Write("x={0},y={1}\"\n",
						((Neuron)neuron).point.X,
						((Neuron)neuron).point.Y
						);
					//					Convert.ToString(((Neuron)neuron).output,new CultureInfo("en-GB")));
				}
			}
			//
			myEnumerator.Reset();
//			myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				IDictionaryEnumerator myWeightsEnumerator = ((Neuron)myEnumerator.Value).weights.GetEnumerator();
				int nNumbNeuron = getNumberOfNeuron((int)myEnumerator.Key);
				while ( myWeightsEnumerator.MoveNext() )
				{
					int nNumb = getNumberOfNeuron((int)(myWeightsEnumerator.Key));
					sr.WriteLine(
						"c:{0}, {1}, {2}",
						nNumbNeuron,
						nNumb,
//						(int)(myWeightsEnumerator.Key),
//						(int)myEnumerator.Key,
						Convert.ToString(((Weight)(myWeightsEnumerator.Value)).dValue,new CultureInfo("en-GB"))
					);
				}
			}
			sr.Close();
		}
		private void initializeNetwork()
		{
			tbbNewNeuron.Pushed = true;
			tbbNewLine.Pushed = false;
			tbbSelectNeuron.Pushed = false;
			menuItemEditorNN.Checked = true;
			menuItemEditorNL.Checked = false;
			menuItemEditorSN.Checked = false;
			neurons = new Hashtable();
			bMoving = false;
			bFirstNeuronLink = true;
			nXbefore = 0;
			nYbefore = 0;
			nextID = 0;
		}
		private void menuItemNetworkNew_Click(object sender, System.EventArgs e)
		{
			
			initializeNetwork();
			Invalidate();
		}
		private void createNeuron(String sNeuronType, Hashtable paramTable)
		{
			Point p = new Point(
				Convert.ToInt16((string)paramTable["x"]),
				Convert.ToInt16((string)paramTable["y"])
				);
			double output;
			if (paramTable["output"] != null)
				output = Convert.ToDouble((String)(paramTable["output"]),new CultureInfo("en-GB"));
			else output = 0;
			if (sNeuronType.CompareTo("*")==0)
			{
				neurons.Add(
					nextID,new NeuronConstant(
					p
					));
				nextID++;
			}
			else if (sNeuronType.CompareTo("D")==0)
			{
				neurons.Add(	
					nextID,
					new NeuronDifferentiate(
					p,
					Convert.ToDouble((string)(paramTable["prevInput"]),new CultureInfo("en-GB")),
					output,false
					)
					);
				nextID++;
			}
			else if (sNeuronType.CompareTo("Rnd")==0)
			{
				neurons.Add(nextID,new NeuronRandom(p,output,false,r)
					);
				nextID++;
			}
			else if (sNeuronType.CompareTo("N")==0)
			{
				neurons.Add(
					nextID,
					new NeuronSigmoidN(
					p,
					Convert.ToDouble((string)(paramTable["sigmo"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["force"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["inertia"]),new CultureInfo("en-GB")),
					output,false
					)
					);
				nextID++;
			}
			else if (sNeuronType.CompareTo("Nu")==0)
			{
				neurons.Add(
					nextID,
					new NeuronSigmoidNu(
					p,
					Convert.ToDouble((string)(paramTable["sigmo"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["force"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["inertia"]),new CultureInfo("en-GB")),
					output,false
					)
					);
				nextID++;
			}
			else if (sNeuronType.CompareTo("Sin")==0)
			{
				neurons.Add(
					nextID,
					new NeuronSinusoid(
					p,
					Convert.ToDouble((string)(paramTable["t"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["f"]),new CultureInfo("en-GB")),
					output,false
					)
					);
				nextID++;
			}
			else if (sNeuronType.CompareTo("Thr")==0)
			{
				neurons.Add(
					nextID,
					new NeuronThreshold(
					p,
					Convert.ToDouble((string)(paramTable["t"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["hi"]),new CultureInfo("en-GB")),
					Convert.ToDouble((string)(paramTable["lo"]),new CultureInfo("en-GB")),
					output,false
					)
					);
				nextID++;
			}
		}
		private void menuItemNetworkOpen_Click(object sender, System.EventArgs e)
		{
			initializeNetwork();
			if( this.openNetworkDialog.ShowDialog(this) != DialogResult.OK ) 
				return;
			string fileName = this.openNetworkDialog.FileName;
			StreamReader sr = File.OpenText(fileName);
			String input;
			while ((input=sr.ReadLine())!=null) 
			{
				if (input[0]=='n') // reading neuron
				{
					int n=1;
					while (n < input.Length)
					{	
						if (input[n] == 'd') // neuron description
						{
							n+=3; // skip ="
							string sNeuronType = "";
							while (input[n]!=':') // get Neuron type
							{
								sNeuronType+= input[n];
								n++;
							}
							Hashtable paramTable = new Hashtable();
							while (input[n]!='"') // to the end of neuron parameters
							{
								n++;
								string sParamName = "";
								while (input[n]!='=') // to the end of neuron paramtere name
								{
									sParamName+=input[n];
									n++;
								}
								n++;
								string sParamValue = "";
								while (input[n]!=',' && input[n]!='"') // to the end of neuron parameter value
								{
									sParamValue+=input[n];
									n++;
								}
								paramTable.Add(sParamName,sParamValue);
							}
							createNeuron(sNeuronType,paramTable);
						}
						n++;
					}
				}
				else if (input[0] == 'c') //reading connection
				{
					int k=2;
					String sTo = "";
					while (input[k] != ',') // connection TO
					{
						sTo += input[k];
						k++;
					}
					k=k+2; // skip ", "
					String sFrom = "";
					while (input[k] != ',')
					{
						sFrom += input[k];
						k++;
					}
					k = k+2;
					String sWeight = "";
					while (k < input.Length)
					{
						sWeight += input[k];
						k++;
					}
//					int from = neurons.Count-1 - Convert.ToInt16(sFrom);
//					int dest = neurons.Count-1 - Convert.ToInt16(sTo);
					int from = Convert.ToInt16(sFrom);
					int dest = Convert.ToInt16(sTo);

					((Neuron)neurons[dest]).weights.Add
						(from,new Weight(Convert.ToDouble(sWeight,new CultureInfo("en-GB")),true));
				} 
				else
				{
					MessageBox.Show("Error reading file!");
				}
			}
			sr.Close();
			updatePanelNetEditorAutoscrollMinSize();
			Invalidate();
		}
		public void resetNetwork(bool bWeights, bool bOutputs, bool bStates, bool bPareameters)
		{
			foreach (DictionaryEntry myEntry in neurons)
			{
				if (bOutputs) ((Neuron)neurons[myEntry.Key]).resetOutput(r);
				else ((Neuron)neurons[myEntry.Key]).resetOutput(r);

				if (bWeights) ((Neuron)neurons[myEntry.Key]).initializeWeights(-1,1,r);
				
				if (bStates)  ((Neuron)neurons[myEntry.Key]).reset(r);
				else ((Neuron)neurons[myEntry.Key]).reset();

				if (bPareameters) ((Neuron)neurons[myEntry.Key]).randomParam(r);
//				else (bPareameters) ((Neuron)neurons[myEntry.Key]).standardParam();
				
			}
			Invalidate();

		}
		private void NetworkReset_Click(object sender, System.EventArgs e)
		{
			resetNetwork(true,true,true,false);
		}

		private void panelNetEditor_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			
			
			Graphics myGraphics = e.Graphics;
			myGraphics.TranslateTransform(panelNetEditor.AutoScrollPosition.X, panelNetEditor.AutoScrollPosition.Y);
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			
			Font myFont = new Font("Times",8);
			SolidBrush myBrush = new SolidBrush(Color.Black);
			
			while ( myEnumerator.MoveNext() )
			{
				((Neuron)myEnumerator.Value).Paint(myGraphics);
				IDictionaryEnumerator myWeightsEnumerator = ((Neuron)myEnumerator.Value).weights.GetEnumerator();
				while (myWeightsEnumerator.MoveNext() )
				{
					Point from = ((Neuron)myEnumerator.Value).point;
					Point to  = ((Neuron)neurons[myWeightsEnumerator.Key]).point;
					from.Offset(-5,0);
					to.Offset(2,0);
					myGraphics.DrawLine(myPenLink,from,to);
					int diiffX = ((((Neuron)neurons[myWeightsEnumerator.Key]).point.X - ((Neuron)myEnumerator.Value).point.X))/2;
					int diiffY = ((((Neuron)neurons[myWeightsEnumerator.Key]).point.Y - ((Neuron)myEnumerator.Value).point.Y))/2;
					Point p = new Point(
						((Neuron)myEnumerator.Value).point.X + (int)(diiffX),
						((Neuron)myEnumerator.Value).point.Y + (int)(diiffY)
						);
					Double d = ((Weight)myWeightsEnumerator.Value).dValue;
					myGraphics.DrawString(d.ToString("0.#"),myFont,myBrush,p);

						
				}
			}
			if (bFirstNeuronLink == false && menuItemEditorNL.Checked == true)
			{
				myGraphics.DrawLine(myPenLink,((Neuron)neurons[firstNeuronLink]).point,mousePoint);
			}
		
		}

		private void panelNetEditor_DoubleClick(object sender, System.EventArgs e)
		{
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				if (((Neuron)myEnumerator.Value).CheckIfOver(mousePoint) == true)
				{
					actNeuron = (int)myEnumerator.Key;
					FormNeuronProperties fnp = new FormNeuronProperties(neurons[actNeuron]);
					if (fnp.ShowDialog()==DialogResult.OK)
					{
						neurons[actNeuron]=fnp.getNeuron();
						Invalidate();
						//fo.RenewComponents();
					}
					return;
				}
				IDictionaryEnumerator myWeightsEnumerator = ((Neuron)myEnumerator.Value).weights.GetEnumerator();
				while (myWeightsEnumerator.MoveNext() )
				{
					GraphicsPath gp = new GraphicsPath();
					gp.AddLine(((Neuron)myEnumerator.Value).point,((Neuron)neurons[myWeightsEnumerator.Key]).point);
					if (gp.IsOutlineVisible(mousePoint,myPenLink)==true)
					{
						WeightEditor we = new WeightEditor((Weight)myWeightsEnumerator.Value);
						if (we.ShowDialog(this) == DialogResult.OK)
						{
							(((Neuron)myEnumerator.Value)).weights[myWeightsEnumerator.Key] = we.weight;
							Invalidate();
							return;
						}
					}
				}			
			}			
		}

		private void panelNetEditor_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point pPos = new Point(e.X-panelNetEditor.AutoScrollPosition.X,e.Y-panelNetEditor.AutoScrollPosition.Y);
	
			//			MessageBox.Show(Convert.ToString(e.X)+":"+Convert.ToString(e.Y)+"Scroll"+Convert.ToString(panelNetEditor.AutoScrollPosition.X)+":"+Convert.ToString(panelNetEditor.AutoScrollPosition.Y));

			mousePoint = new Point(pPos.X,pPos.Y);
				
			if (e.Button == MouseButtons.Left) 
			{	
				//new neuron
				if (menuItemEditorNN.Checked == true)
				{
					
					FormNeuronProperties fnp = new FormNeuronProperties(new NeuronSigmoidN(new Point(pPos.X,pPos.Y),2,0.04,0.8,0,false));
					if (fnp.ShowDialog()==DialogResult.OK)
					{
						neurons.Add(nextID,fnp.getNeuron());
						nextID++;
						Invalidate();
					//	fo.RenewComponents();
					}
					return;
				}
				actNeuron = -1;
				IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
				while ( myEnumerator.MoveNext() )
				{
					if (((Neuron)myEnumerator.Value).CheckIfOver(new Point(pPos.X,pPos.Y)) == true)
						actNeuron = (int)myEnumerator.Key;
				}
				
				if (menuItemEditorSN.Checked == true && actNeuron!= -1)
				{
					bMoving = true;
					nXbefore = pPos.X;
					nYbefore = pPos.Y;
					return;
				}
				//new link
				if (menuItemEditorNL.Checked == true)
				{
					if (actNeuron != -1)
					{
						
						if (bFirstNeuronLink == true)
						{
							firstNeuronLink = actNeuron;
							bFirstNeuronLink = false;
						}
						else
						{
							secondNeuronLink = actNeuron;
							bFirstNeuronLink = true;
							WeightEditor we = new WeightEditor(new Weight());
							if (we.ShowDialog(this) == DialogResult.OK)
							{
								((Neuron)neurons[secondNeuronLink]).weights.Add(firstNeuronLink,we.weight);
							}

							Invalidate();
							return;

							// pocz dwa neurony
						}
						
					}
					 
				}
			}
			else if (e.Button == MouseButtons.Right)
			{
				IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
				while ( myEnumerator.MoveNext() )
				{
					if (((Neuron)myEnumerator.Value).CheckIfOver(new Point(pPos.X,pPos.Y)) == true)
					{
						IDictionaryEnumerator myEnumeratorInside = neurons.GetEnumerator();
						while ( myEnumeratorInside.MoveNext() )
						{
							if (((Neuron)myEnumeratorInside.Value).weights.ContainsKey(myEnumerator.Key) == true)
								((Neuron)myEnumeratorInside.Value).weights.Remove(myEnumerator.Key);
						}
				
						neurons.Remove(myEnumerator.Key);
						Invalidate();
						return;
					}
					IDictionaryEnumerator myWeightsEnumerator = ((Neuron)myEnumerator.Value).weights.GetEnumerator();
					while (myWeightsEnumerator.MoveNext() )
					{
						GraphicsPath gp = new GraphicsPath();
						gp.AddLine(((Neuron)myEnumerator.Value).point,((Neuron)neurons[myWeightsEnumerator.Key]).point);
						if (gp.IsOutlineVisible(mousePoint,myPenLink)==true)
						{
							((Neuron)myEnumerator.Value).weights.Remove(myWeightsEnumerator.Key);
							Invalidate();
							return;					
						}
					}			
				}
			}
		}
		private int getMaxXPos()
		{
			int maxX = 0;
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				if (((Neuron)myEnumerator.Value).point.X > maxX)
					maxX = ((Neuron)myEnumerator.Value).point.X;
			}
			return maxX;
		}
		private int getMaxYPos()
		{
			int maxY = 0;
			IDictionaryEnumerator myEnumerator = neurons.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				if (((Neuron)myEnumerator.Value).point.Y > maxY)
					maxY = ((Neuron)myEnumerator.Value).point.Y;
			}
			return maxY;
		}
		private void updatePanelNetEditorAutoscrollMinSize()
		{
			panelNetEditor.AutoScrollMinSize = new Size(getMaxXPos()+15,getMaxYPos()+15);
		}
		private void updatePanelNetEditorAutoScrollPosition(Point pPos)
		{
			if (pPos.X > panelNetEditor.Width-panelNetEditor.AutoScrollPosition.X && pPos.Y > panelNetEditor.Height - panelNetEditor.AutoScrollPosition.Y)
			{

				panelNetEditor.AutoScrollPosition = new Point(pPos.X+15,pPos.Y+15);

			}
			else if ( pPos.X > panelNetEditor.Width-panelNetEditor.AutoScrollPosition.X)
			{
				//updateAutoscrollMinSize();
				panelNetEditor.AutoScrollPosition = new Point(pPos.X+15,-panelNetEditor.AutoScrollPosition.Y);
			}
			else if (pPos.Y > panelNetEditor.Height - panelNetEditor.AutoScrollPosition.Y)
			{
				//updateAutoscrollMinSize();
				panelNetEditor.AutoScrollPosition = new Point(-panelNetEditor.AutoScrollPosition.X,pPos.Y+15);
			}
			else if (pPos.Y < - panelNetEditor.AutoScrollPosition.Y)
			{
				//updateAutoscrollMinSize();
				//	if (pPos.Y >= getMaxYPos())
				//			panelNetEditor.AutoScrollMinSize = new Size(panelNetEditor.AutoScrollMinSize.Width,pPos.Y+15);
				panelNetEditor.AutoScrollPosition = new Point(-panelNetEditor.AutoScrollPosition.X,pPos.Y+15);						
			}
			else if (pPos.X < -panelNetEditor.AutoScrollPosition.X)
			{
				//updateAutoscrollMinSize();
				//	if (pPos.X >= getMaxXPos())
				//		panelNetEditor.AutoScrollMinSize = new Size(pPos.X+15,panelNetEditor.AutoScrollMinSize.Height);
				panelNetEditor.AutoScrollPosition = new Point(pPos.X+15,-panelNetEditor.AutoScrollPosition.Y);
			}
			else if (pPos.X < -panelNetEditor.AutoScrollPosition.X && pPos.Y < - panelNetEditor.AutoScrollPosition.Y)
			{
				///updateAutoscrollMinSize();
				//	if (pPos.X >= getMaxXPos() && pPos.Y >= getMaxYPos())
				//		panelNetEditor.AutoScrollMinSize = new Size(pPos.X+15,pPos.Y+15);
				panelNetEditor.AutoScrollPosition = new Point(pPos.X+15,pPos.Y+15);
			}
		}

		private void panelNetEditor_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point pPos = new Point(e.X-panelNetEditor.AutoScrollPosition.X,e.Y-panelNetEditor.AutoScrollPosition.Y);
			if (pPos.X >= 5 && pPos.Y >= 5)
			{
				if (bMoving == true)
				{
					if (e.X > panelNetEditor.Width || e.X < 5 || e.Y > panelNetEditor.Height || e.Y < 5)
					{
						updatePanelNetEditorAutoscrollMinSize();
					}
					updatePanelNetEditorAutoScrollPosition(pPos);

					((Neuron)neurons[actNeuron]).moveBy(new Point(pPos.X-nXbefore,pPos.Y-nYbefore));
					nXbefore = pPos.X;
					nYbefore = pPos.Y;
					Invalidate();
				}
				else if (bFirstNeuronLink == false && menuItemEditorNL.Checked == true)
				{
					mousePoint = new Point(pPos.X,pPos.Y);
					updatePanelNetEditorAutoScrollPosition(pPos);
					Invalidate();
					return;

				}
			}
		}

		private void panelNetEditor_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
				bMoving = false;
		}

		private void vScrollBar2_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
		
		}

		private void panelNetEditor_Resize(object sender, System.EventArgs e)
		{

		}

		private void menuItemNetworkOptimize_Click(object sender, System.EventArgs e)
		{
			FormNetworkOptimization fo = new FormNetworkOptimization(this);
			fo.Show();
		}

		private void menuItemHelpHelp_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Tu otworzy si przegldarka WWW z oknem pomocy");
		}
	}
}
