using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using WCLNeuronDiagramOpt;

namespace NeuroX
{
	/// <summary>
	/// Summary description for FormNetworkOptimization.
	/// </summary>
	public class FormNetworkOptimization : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private FormEditor formEditor;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button buttonOptimize;
		private System.Windows.Forms.NumericUpDown numericUpDownNumOfIntervals;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.NumericUpDown numericUpDownNumberOfIt;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox cbRandomizeParameters;
		private System.Windows.Forms.CheckBox cbRandomizeinitialstates;
		private System.Windows.Forms.CheckBox cbRandomizeOutputs;
		private System.Windows.Forms.CheckBox cbRandomizeWeights;
		private System.Windows.Forms.CheckBox cbSynchronic;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox gbOptimization;
		private System.Windows.Forms.TextBox tbError;
		private Panel p1;
		public void RenewComponents()
		{
			//IEnumerator myEnum = components.Components.GetEnumerator();
			if (ucNeuronDiagrList.Count > 0)
			{
//				components.Dispose();
	//			InitializeComponent();
			}
//			for (int k=0;k<ucNeuronDiagrList.Count;k++)
//			{
//				this.components.Remove((System.ComponentModel.IComponent)ucNeuronDiagrList[k]);
////				ucNeuronDiagrList.RemoveAt(k);
//			}
			IDictionaryEnumerator myEnumerator = formEditor.neurons.GetEnumerator();
			int i=0;

			while ( myEnumerator.MoveNext() ) // create 3 dimensional table
			{
				if (((Neuron)myEnumerator.Value).bOptimize == true)
				{
					WCLNeuronDiagramOpt.ucNeuronDiagrOpt uc = new WCLNeuronDiagramOpt.ucNeuronDiagrOpt((int)myEnumerator.Key);		
					this.Controls.AddRange(new System.Windows.Forms.Control[] {uc});
					uc.Location = new Point(0,gbOptimization.Height+i*170);
					uc.Height = 150;
					uc.Width = this.Width-10;
					ucNeuronDiagrList.Add(uc);
					((WCLNeuronDiagramOpt.ucNeuronDiagrOpt)this.ucNeuronDiagrList[i]).Enter += new System.EventHandler(this.component_Click);
					((WCLNeuronDiagramOpt.ucNeuronDiagrOpt)this.ucNeuronDiagrList[i]).Leave += new System.EventHandler(this.component_ClickLeave);
					i++;
				}
			}
		}

		public FormNetworkOptimization(FormEditor formEditor)
		{
			this.formEditor = formEditor;
			InitializeComponent();
			p1 = new Panel();
			p1.BackColor = Color.Black;
			p1.Show();
			p1.Size = new Size(500,500);
			ucNeuronDiagrList = new ArrayList();
			RenewComponents();
	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gbOptimization = new System.Windows.Forms.GroupBox();
			this.numericUpDownNumOfIntervals = new System.Windows.Forms.NumericUpDown();
			this.label5 = new System.Windows.Forms.Label();
			this.numericUpDownNumberOfIt = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.tbError = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.buttonOptimize = new System.Windows.Forms.Button();
			this.cbRandomizeParameters = new System.Windows.Forms.CheckBox();
			this.cbRandomizeinitialstates = new System.Windows.Forms.CheckBox();
			this.cbRandomizeOutputs = new System.Windows.Forms.CheckBox();
			this.cbRandomizeWeights = new System.Windows.Forms.CheckBox();
			this.cbSynchronic = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.gbOptimization.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownNumOfIntervals)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownNumberOfIt)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// gbOptimization
			// 
			this.gbOptimization.Controls.Add(this.numericUpDownNumOfIntervals);
			this.gbOptimization.Controls.Add(this.label5);
			this.gbOptimization.Controls.Add(this.numericUpDownNumberOfIt);
			this.gbOptimization.Controls.Add(this.label1);
			this.gbOptimization.Controls.Add(this.tbError);
			this.gbOptimization.Controls.Add(this.label3);
			this.gbOptimization.Controls.Add(this.buttonOptimize);
			this.gbOptimization.Location = new System.Drawing.Point(0, 0);
			this.gbOptimization.Name = "gbOptimization";
			this.gbOptimization.Size = new System.Drawing.Size(480, 144);
			this.gbOptimization.TabIndex = 13;
			this.gbOptimization.TabStop = false;
			this.gbOptimization.Text = "Optimization";
			// 
			// numericUpDownNumOfIntervals
			// 
			this.numericUpDownNumOfIntervals.Location = new System.Drawing.Point(176, 80);
			this.numericUpDownNumOfIntervals.Maximum = new System.Decimal(new int[] {
																						10000,
																						0,
																						0,
																						0});
			this.numericUpDownNumOfIntervals.Minimum = new System.Decimal(new int[] {
																						50,
																						0,
																						0,
																						0});
			this.numericUpDownNumOfIntervals.Name = "numericUpDownNumOfIntervals";
			this.numericUpDownNumOfIntervals.Size = new System.Drawing.Size(80, 20);
			this.numericUpDownNumOfIntervals.TabIndex = 23;
			this.numericUpDownNumOfIntervals.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDownNumOfIntervals.Value = new System.Decimal(new int[] {
																					  100,
																					  0,
																					  0,
																					  0});
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 80);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(120, 16);
			this.label5.TabIndex = 22;
			this.label5.Text = "Width of interval range";
			// 
			// numericUpDownNumberOfIt
			// 
			this.numericUpDownNumberOfIt.Increment = new System.Decimal(new int[] {
																					  50,
																					  0,
																					  0,
																					  0});
			this.numericUpDownNumberOfIt.Location = new System.Drawing.Point(176, 40);
			this.numericUpDownNumberOfIt.Maximum = new System.Decimal(new int[] {
																					100000,
																					0,
																					0,
																					0});
			this.numericUpDownNumberOfIt.Minimum = new System.Decimal(new int[] {
																					1,
																					0,
																					0,
																					0});
			this.numericUpDownNumberOfIt.Name = "numericUpDownNumberOfIt";
			this.numericUpDownNumberOfIt.Size = new System.Drawing.Size(80, 20);
			this.numericUpDownNumberOfIt.TabIndex = 19;
			this.numericUpDownNumberOfIt.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDownNumberOfIt.Value = new System.Decimal(new int[] {
																				  50,
																				  0,
																				  0,
																				  0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 16);
			this.label1.TabIndex = 18;
			this.label1.Text = "Number of iterations";
			// 
			// tbError
			// 
			this.tbError.Enabled = false;
			this.tbError.Location = new System.Drawing.Point(352, 40);
			this.tbError.Name = "tbError";
			this.tbError.Size = new System.Drawing.Size(104, 20);
			this.tbError.TabIndex = 12;
			this.tbError.Text = "";
			this.tbError.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(280, 40);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 23);
			this.label3.TabIndex = 11;
			this.label3.Text = "Overall error";
			// 
			// buttonOptimize
			// 
			this.buttonOptimize.Location = new System.Drawing.Point(328, 104);
			this.buttonOptimize.Name = "buttonOptimize";
			this.buttonOptimize.Size = new System.Drawing.Size(104, 24);
			this.buttonOptimize.TabIndex = 10;
			this.buttonOptimize.Text = "Optimize";
			this.buttonOptimize.Click += new System.EventHandler(this.buttonOptimize_Click);
			// 
			// cbRandomizeParameters
			// 
			this.cbRandomizeParameters.Location = new System.Drawing.Point(32, 88);
			this.cbRandomizeParameters.Name = "cbRandomizeParameters";
			this.cbRandomizeParameters.Size = new System.Drawing.Size(136, 24);
			this.cbRandomizeParameters.TabIndex = 28;
			this.cbRandomizeParameters.Text = "randomize parameters";
			// 
			// cbRandomizeinitialstates
			// 
			this.cbRandomizeinitialstates.Location = new System.Drawing.Point(32, 64);
			this.cbRandomizeinitialstates.Name = "cbRandomizeinitialstates";
			this.cbRandomizeinitialstates.Size = new System.Drawing.Size(144, 24);
			this.cbRandomizeinitialstates.TabIndex = 27;
			this.cbRandomizeinitialstates.Text = "randomize initial states";
			// 
			// cbRandomizeOutputs
			// 
			this.cbRandomizeOutputs.Location = new System.Drawing.Point(32, 40);
			this.cbRandomizeOutputs.Name = "cbRandomizeOutputs";
			this.cbRandomizeOutputs.Size = new System.Drawing.Size(152, 24);
			this.cbRandomizeOutputs.TabIndex = 26;
			this.cbRandomizeOutputs.Text = "randomize initial outputs";
			// 
			// cbRandomizeWeights
			// 
			this.cbRandomizeWeights.Checked = true;
			this.cbRandomizeWeights.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbRandomizeWeights.Location = new System.Drawing.Point(32, 16);
			this.cbRandomizeWeights.Name = "cbRandomizeWeights";
			this.cbRandomizeWeights.Size = new System.Drawing.Size(120, 24);
			this.cbRandomizeWeights.TabIndex = 25;
			this.cbRandomizeWeights.Text = "randomize weights";
			// 
			// cbSynchronic
			// 
			this.cbSynchronic.Checked = true;
			this.cbSynchronic.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbSynchronic.Location = new System.Drawing.Point(32, 112);
			this.cbSynchronic.Name = "cbSynchronic";
			this.cbSynchronic.Size = new System.Drawing.Size(144, 24);
			this.cbSynchronic.TabIndex = 24;
			this.cbSynchronic.Text = "synchronic optimization";
			this.cbSynchronic.CheckedChanged += new System.EventHandler(this.cbSynchronic_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.cbRandomizeParameters);
			this.groupBox1.Controls.Add(this.cbRandomizeinitialstates);
			this.groupBox1.Controls.Add(this.cbRandomizeOutputs);
			this.groupBox1.Controls.Add(this.cbRandomizeWeights);
			this.groupBox1.Controls.Add(this.cbSynchronic);
			this.groupBox1.Location = new System.Drawing.Point(480, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(208, 144);
			this.groupBox1.TabIndex = 14;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Options";
			// 
			// FormNetworkOptimization
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(688, 333);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.gbOptimization);
			this.Name = "FormNetworkOptimization";
			this.Text = "Network optimization";
			this.Resize += new System.EventHandler(this.FormNetworkOptimization_Resize);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.FormNetworkOptimization_Paint);
			this.gbOptimization.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownNumOfIntervals)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownNumberOfIt)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

	
	

		private void FormNetworkOptimization_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{

		}

		private void ucNeuronDiagrOpt1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void numericUpDownNumOfIntervals_ValueChanged(object sender, System.EventArgs e)
		{
			//ucNeuronDiagrOpt.setDiagramParams((int)numericUpDownNumOfIntervals.Value,null);
				
		}
		private ArrayList ucNeuronDiagrList;

		private void buttonOptimize_Click(object sender, System.EventArgs e)
		{
			if (cbSynchronic.Checked) optimizeSynchronic();
			else optimizeAsynchronic();
		}

		private void component_Click(object sender, System.EventArgs e)
		{
//			MessageBox.Show("ok");
			((Neuron)formEditor.neurons[((WCLNeuronDiagramOpt.ucNeuronDiagrOpt) sender).number]).bChoosen = true;
			formEditor.Invalidate();
		}
		private void component_ClickLeave(object sender, System.EventArgs e)
		{
			((Neuron)formEditor.neurons[((WCLNeuronDiagramOpt.ucNeuronDiagrOpt) sender).number]).bChoosen = false;
			formEditor.Invalidate();
		}

		private void optimizeAsynchronic()
		{
			double minError = 999999999; //big value
			Hashtable neuronsOptimizedBest = new Hashtable();

			for (int i=0;i<numericUpDownNumberOfIt.Value;i++)
			{
				formEditor.resetNetwork(cbRandomizeWeights.Checked,cbRandomizeOutputs.Checked,cbRandomizeinitialstates.Checked,cbRandomizeParameters.Checked);
				Hashtable neuronsOptimized = new Hashtable();
				Hashtable neuronsOutputs = new Hashtable();
				IEnumerator neuronKeysEnum = formEditor.neurons.Keys.GetEnumerator();
				
				while (neuronKeysEnum.MoveNext())
				{
					Neuron neuron = (Neuron)formEditor.neurons[neuronKeysEnum.Current];
					if (neuron.bOptimize == true)
					{
						neuronsOptimized.Add(neuronKeysEnum.Current,new ArrayList());
						neuronsOutputs.Add(neuronKeysEnum.Current,new ArrayList());
					}
				}
				IEnumerator neuronOptimizedKeysEnum = neuronsOptimized.Keys.GetEnumerator();
				for (int j=0;j<numericUpDownNumOfIntervals.Value;j++) // step all network through intervals
				{
					formEditor.networkStep();
					neuronOptimizedKeysEnum.Reset();
					while (neuronOptimizedKeysEnum.MoveNext())
					{
						ArrayList oneNeuron = (ArrayList) neuronsOptimized[neuronOptimizedKeysEnum.Current];
						ArrayList oneNeuronOutputs =  (ArrayList) neuronsOutputs[neuronOptimizedKeysEnum.Current];
						Neuron n = (Neuron)formEditor.neurons[neuronOptimizedKeysEnum.Current];
						oneNeuron.Add(n.Clone());
						oneNeuronOutputs.Add(n.output);
					}
				}
				
				Hashtable errorIndexList = new Hashtable();
				Hashtable errorList = new Hashtable();
				neuronOptimizedKeysEnum.Reset();
				while (neuronOptimizedKeysEnum.MoveNext())
				{
					errorList.Add(neuronOptimizedKeysEnum.Current,(double)9999999.99);
					errorIndexList.Add(neuronOptimizedKeysEnum.Current,(int)-1);
				}
				double globalError = 0.0;
				neuronOptimizedKeysEnum.Reset();
				int k=0;
				while (neuronOptimizedKeysEnum.MoveNext())
				{
				
					bool bBreak = false;
					
					for (int z=0;z<(int)numericUpDownNumOfIntervals.Value;z++)
					{
						
						ucNeuronDiagrOpt aktContr = (ucNeuronDiagrOpt)ucNeuronDiagrList[k];
						int userWitdh = (int) aktContr.numericUpDownUserIntervals.Value;
						if (z+userWitdh >= (int)numericUpDownNumOfIntervals.Value)
							bBreak = true;
				
						ArrayList aktNeuronArray = (ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current];
						double error = aktContr.getNetowrkError(aktNeuronArray,z);
						if (error < (double)errorList[neuronOptimizedKeysEnum.Current])
						{
							errorList[neuronOptimizedKeysEnum.Current] = error;
							errorIndexList[neuronOptimizedKeysEnum.Current] = z;
						}
						if (bBreak == true) break;
					}
					globalError += (double)(errorList[neuronOptimizedKeysEnum.Current]);
					k++;
					
				}
				neuronOptimizedKeysEnum.Reset();
				int zz=0;
				// updating uc
				if (globalError < minError)
				{
					minError = globalError;
					while (neuronOptimizedKeysEnum.MoveNext())
					{
						ArrayList oneNeuronArray = (ArrayList) neuronsOptimized[neuronOptimizedKeysEnum.Current];
						int z = (int)errorIndexList[neuronOptimizedKeysEnum.Current];
						Neuron n = (Neuron) oneNeuronArray[z];
						neuronsOptimizedBest[neuronOptimizedKeysEnum.Current] = n.Clone();
						formEditor.neurons[neuronOptimizedKeysEnum.Current] = n;
							
						if (n.output != (double)((ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current])[z])
							MessageBox.Show("Niezgadza si");
						ucNeuronDiagrOpt uc = (ucNeuronDiagrOpt) ucNeuronDiagrList[zz];
							
						uc.setDiagramParams((ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current],z);
							
						uc.Invalidate(true);
							
						formEditor.Invalidate();
							
						zz++;
					}
				}
			}
			IEnumerator neuronOptimizedBestKeysEnum = neuronsOptimizedBest.Keys.GetEnumerator();
			while (neuronOptimizedBestKeysEnum.MoveNext())
			{
				
				Neuron n = (Neuron) neuronsOptimizedBest[neuronOptimizedBestKeysEnum.Current];
				formEditor.neurons[neuronOptimizedBestKeysEnum.Current] = n;
			}
			tbError.Text = Convert.ToString(minError);
			formEditor.Invalidate();
		}

		private void optimizeSynchronic()
		{
			double minError = 999999999; //big value
			Hashtable neuronsOptimizedBest = new Hashtable();

			for (int i=0;i<numericUpDownNumberOfIt.Value;i++)
			{
				formEditor.resetNetwork(cbRandomizeWeights.Checked,cbRandomizeOutputs.Checked,cbRandomizeinitialstates.Checked,cbRandomizeParameters.Checked);
				Hashtable neuronsOptimized = new Hashtable();
				Hashtable neuronsOutputs = new Hashtable();
				IEnumerator neuronKeysEnum = formEditor.neurons.Keys.GetEnumerator();
				
				while (neuronKeysEnum.MoveNext())
				{
					Neuron neuron = (Neuron)formEditor.neurons[neuronKeysEnum.Current];
					if (neuron.bOptimize == true)
					{
						neuronsOptimized.Add(neuronKeysEnum.Current,new ArrayList());
						neuronsOutputs.Add(neuronKeysEnum.Current,new ArrayList());
					}
				}
				IEnumerator neuronOptimizedKeysEnum = neuronsOptimized.Keys.GetEnumerator();
				for (int j=0;j<numericUpDownNumOfIntervals.Value;j++) // step all network through intervals
				{
					formEditor.networkStep();
					neuronOptimizedKeysEnum.Reset();
					while (neuronOptimizedKeysEnum.MoveNext())
					{
						ArrayList oneNeuron = (ArrayList) neuronsOptimized[neuronOptimizedKeysEnum.Current];
						ArrayList oneNeuronOutputs =  (ArrayList) neuronsOutputs[neuronOptimizedKeysEnum.Current];
						Neuron n = (Neuron)formEditor.neurons[neuronOptimizedKeysEnum.Current];
						oneNeuron.Add(n.Clone());
						oneNeuronOutputs.Add(n.output);
					}
				}
				
				for (int z=0;z<(int)numericUpDownNumOfIntervals.Value;z++)
				{
					double error = 0;
   					neuronOptimizedKeysEnum.Reset();
					int k=0;
					bool bBreak = false;
					while (neuronOptimizedKeysEnum.MoveNext())
					{
						ucNeuronDiagrOpt aktContr = (ucNeuronDiagrOpt)ucNeuronDiagrList[k];
						int userWitdh = (int) aktContr.numericUpDownUserIntervals.Value;
						if (z+userWitdh >= (int)numericUpDownNumOfIntervals.Value)
							bBreak = true;
						k++;
						ArrayList aktNeuronArray = (ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current];
						error += aktContr.getNetowrkError(aktNeuronArray,z);
					}
					if (bBreak == true) break;
					if (error < minError)
					{
						minError = error;
						neuronOptimizedKeysEnum.Reset();
						int zz=0;
						while (neuronOptimizedKeysEnum.MoveNext())
						{
							ArrayList oneNeuronArray = (ArrayList) neuronsOptimized[neuronOptimizedKeysEnum.Current];
							
							Neuron n = (Neuron) oneNeuronArray[z];
							neuronsOptimizedBest[neuronOptimizedKeysEnum.Current] = n.Clone();
							formEditor.neurons[neuronOptimizedKeysEnum.Current] = n;
							
							if (n.output != (double)((ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current])[z])
								MessageBox.Show("Niezgadza si");

							
							ucNeuronDiagrOpt uc = (ucNeuronDiagrOpt) ucNeuronDiagrList[zz];
							
							uc.setDiagramParams((ArrayList)neuronsOutputs[neuronOptimizedKeysEnum.Current],z);
							
							uc.Invalidate(true);
							
							formEditor.Invalidate();
							
							zz++;
						}
					}
				}
			}
			IEnumerator neuronOptimizedBestKeysEnum = neuronsOptimizedBest.Keys.GetEnumerator();
			while (neuronOptimizedBestKeysEnum.MoveNext())
			{
				
				Neuron n = (Neuron) neuronsOptimizedBest[neuronOptimizedBestKeysEnum.Current];
				formEditor.neurons[neuronOptimizedBestKeysEnum.Current] = n;
			}
			tbError.Text = Convert.ToString(minError);
			formEditor.Invalidate();
		}

		private void FormNetworkOptimization_Resize(object sender, System.EventArgs e)
		{
			for (int i=0; i<ucNeuronDiagrList.Count;i++)
			{
				if (this.Width > 716)
					((WCLNeuronDiagramOpt.ucNeuronDiagrOpt)ucNeuronDiagrList[i]).Width = this.Width-20;
				else ((WCLNeuronDiagramOpt.ucNeuronDiagrOpt)ucNeuronDiagrList[i]).Width = 696;
			}
		}

		private void cbSynchronic_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
