using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NeuroX
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class FormNeuronProperties : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormNeuronProperties(Object neuron)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.neuron = neuron;
			if (((Neuron)neuron).bOptimize == true)
				cbOptimize.Checked = true;
			if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronDifferentiate")==0) 
			{
				rbDifferentiate.Checked = true;
				gbDifferentiate.Visible = true;
				tbDifPrevValue.Text = Convert.ToString(((NeuronDifferentiate)neuron).prevInput);

			} 
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronConstant")==0) 
			{
				rbConstant.Checked = true;
				gbConstant.Visible = true;
				cbOptimize.Checked = false;
				cbOptimize.Enabled = false;
			} 
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronRandom")==0) 
			{
				rbRandom.Checked = true;
				gbRandom.Visible = true;
			}
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSigmoidN")==0) 
			{
				rbSigmoid.Checked = true;
				gbSigmoid.Visible = true;
				rbN.Checked = true;
				tbSigmo.Text = Convert.ToString(((NeuronSigmoidN)neuron).sigmo);
				tbForce.Text = Convert.ToString(((NeuronSigmoidN)neuron).force);
				tbInteria.Text = Convert.ToString(((NeuronSigmoidN)neuron).inertia);

			}
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSigmoidNu")==0) 
			{
				rbSigmoid.Checked = true;
				gbSigmoid.Visible = true;
				rbNu.Checked = true;
				tbSigmo.Text = Convert.ToString(((NeuronSigmoidNu)neuron).sigmo);
				tbForce.Text = Convert.ToString(((NeuronSigmoidNu)neuron).force);
				tbInteria.Text = Convert.ToString(((NeuronSigmoidNu)neuron).inertia);
			}
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronSinusoid")==0) 
			{
				rbSinusoid.Checked = true;
				gbSinusoid.Visible = true;
				tbf0.Text = Convert.ToString(((NeuronSinusoid)neuron).f0);
				tbt.Text = Convert.ToString(((NeuronSinusoid)neuron).t);
			}
			else if (neuron.GetType().ToString().CompareTo("NeuroX.NeuronThreshold")==0) 
			{
				tbThreHi.Text = Convert.ToString(((NeuronThreshold)neuron).hi);
				tbThreLo.Text = Convert.ToString(((NeuronThreshold)neuron).lo);
				tbThrT.Text = Convert.ToString(((NeuronThreshold)neuron).t);
				rbThreshold.Checked = true;
				gbThreshold.Visible = true;
			}
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBoxNeuronType = new System.Windows.Forms.GroupBox();
			this.rbConstant = new System.Windows.Forms.RadioButton();
			this.rbSinusoid = new System.Windows.Forms.RadioButton();
			this.rbRandom = new System.Windows.Forms.RadioButton();
			this.rbThreshold = new System.Windows.Forms.RadioButton();
			this.rbDifferentiate = new System.Windows.Forms.RadioButton();
			this.rbSigmoid = new System.Windows.Forms.RadioButton();
			this.gbSinusoid = new System.Windows.Forms.GroupBox();
			this.label9 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.tbt = new System.Windows.Forms.TextBox();
			this.label11 = new System.Windows.Forms.Label();
			this.tbf0 = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.gbSigmoid = new System.Windows.Forms.GroupBox();
			this.label22 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.lSigmo = new System.Windows.Forms.Label();
			this.tbInteria = new System.Windows.Forms.TextBox();
			this.tbForce = new System.Windows.Forms.TextBox();
			this.tbSigmo = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label19 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.rbN = new System.Windows.Forms.RadioButton();
			this.rbNu = new System.Windows.Forms.RadioButton();
			this.gbDifferentiate = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tbDifPrevValue = new System.Windows.Forms.TextBox();
			this.gbThreshold = new System.Windows.Forms.GroupBox();
			this.tbThreLo = new System.Windows.Forms.TextBox();
			this.tbThreHi = new System.Windows.Forms.TextBox();
			this.tbThrT = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.buttonDefault = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonOk = new System.Windows.Forms.Button();
			this.gbConstant = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.gbRandom = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.cbOptimize = new System.Windows.Forms.CheckBox();
			this.groupBoxNeuronType.SuspendLayout();
			this.gbSinusoid.SuspendLayout();
			this.gbSigmoid.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.gbDifferentiate.SuspendLayout();
			this.gbThreshold.SuspendLayout();
			this.gbConstant.SuspendLayout();
			this.gbRandom.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBoxNeuronType
			// 
			this.groupBoxNeuronType.Controls.AddRange(new System.Windows.Forms.Control[] {
																							 this.rbConstant,
																							 this.rbSinusoid,
																							 this.rbRandom,
																							 this.rbThreshold,
																							 this.rbDifferentiate,
																							 this.rbSigmoid});
			this.groupBoxNeuronType.Location = new System.Drawing.Point(8, 8);
			this.groupBoxNeuronType.Name = "groupBoxNeuronType";
			this.groupBoxNeuronType.Size = new System.Drawing.Size(136, 224);
			this.groupBoxNeuronType.TabIndex = 0;
			this.groupBoxNeuronType.TabStop = false;
			this.groupBoxNeuronType.Text = "Type of neuron";
			// 
			// rbConstant
			// 
			this.rbConstant.Location = new System.Drawing.Point(16, 184);
			this.rbConstant.Name = "rbConstant";
			this.rbConstant.Size = new System.Drawing.Size(112, 24);
			this.rbConstant.TabIndex = 5;
			this.rbConstant.Text = "constant (*)";
			this.rbConstant.CheckedChanged += new System.EventHandler(this.rbConstant_CheckedChanged);
			// 
			// rbSinusoid
			// 
			this.rbSinusoid.Location = new System.Drawing.Point(16, 152);
			this.rbSinusoid.Name = "rbSinusoid";
			this.rbSinusoid.TabIndex = 4;
			this.rbSinusoid.Text = "sinusoid (Sin)";
			this.rbSinusoid.CheckedChanged += new System.EventHandler(this.rbSinusoid_CheckedChanged);
			// 
			// rbRandom
			// 
			this.rbRandom.Location = new System.Drawing.Point(16, 120);
			this.rbRandom.Name = "rbRandom";
			this.rbRandom.TabIndex = 3;
			this.rbRandom.Text = "random (Rnd)";
			this.rbRandom.CheckedChanged += new System.EventHandler(this.rbRandom_CheckedChanged);
			// 
			// rbThreshold
			// 
			this.rbThreshold.Location = new System.Drawing.Point(16, 88);
			this.rbThreshold.Name = "rbThreshold";
			this.rbThreshold.TabIndex = 2;
			this.rbThreshold.Text = "threshold (Thr)";
			this.rbThreshold.CheckedChanged += new System.EventHandler(this.rbThreshold_CheckedChanged);
			// 
			// rbDifferentiate
			// 
			this.rbDifferentiate.Location = new System.Drawing.Point(16, 56);
			this.rbDifferentiate.Name = "rbDifferentiate";
			this.rbDifferentiate.TabIndex = 1;
			this.rbDifferentiate.Text = "differentiate (D)";
			this.rbDifferentiate.CheckedChanged += new System.EventHandler(this.rbDifferentiate_CheckedChanged);
			// 
			// rbSigmoid
			// 
			this.rbSigmoid.Location = new System.Drawing.Point(16, 24);
			this.rbSigmoid.Name = "rbSigmoid";
			this.rbSigmoid.Size = new System.Drawing.Size(112, 24);
			this.rbSigmoid.TabIndex = 0;
			this.rbSigmoid.Text = "sigmoid (N/Nu)";
			this.rbSigmoid.CheckedChanged += new System.EventHandler(this.rbSigmoid_CheckedChanged);
			// 
			// gbSinusoid
			// 
			this.gbSinusoid.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.label9,
																					 this.label12,
																					 this.tbt,
																					 this.label11,
																					 this.tbf0,
																					 this.label10});
			this.gbSinusoid.Location = new System.Drawing.Point(160, 8);
			this.gbSinusoid.Name = "gbSinusoid";
			this.gbSinusoid.Size = new System.Drawing.Size(440, 224);
			this.gbSinusoid.TabIndex = 10;
			this.gbSinusoid.TabStop = false;
			this.gbSinusoid.Text = "Sinusoid neuron";
			this.gbSinusoid.Visible = false;
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 32);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(392, 32);
			this.label9.TabIndex = 12;
			this.label9.Text = "The output sinusoid has frequency f and initial phase t. The output frequency dep" +
				"ends on the neuron input value.";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(80, 128);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(112, 23);
			this.label12.TabIndex = 11;
			this.label12.Text = "t /time/ - initial phase";
			// 
			// tbt
			// 
			this.tbt.Location = new System.Drawing.Point(208, 128);
			this.tbt.Name = "tbt";
			this.tbt.Size = new System.Drawing.Size(104, 20);
			this.tbt.TabIndex = 10;
			this.tbt.Text = "0";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(80, 168);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(296, 24);
			this.label11.TabIndex = 9;
			this.label11.Text = "f/the output frequency/ = t+f0+current_input_value";
			// 
			// tbf0
			// 
			this.tbf0.Location = new System.Drawing.Point(208, 88);
			this.tbf0.Name = "tbf0";
			this.tbf0.Size = new System.Drawing.Size(104, 20);
			this.tbf0.TabIndex = 8;
			this.tbf0.Text = "0";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(80, 88);
			this.label10.Name = "label10";
			this.label10.TabIndex = 7;
			this.label10.Text = "f0 /base frequency/";
			// 
			// gbSigmoid
			// 
			this.gbSigmoid.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label22,
																					this.label21,
																					this.label20,
																					this.label15,
																					this.label14,
																					this.lSigmo,
																					this.tbInteria,
																					this.tbForce,
																					this.tbSigmo,
																					this.groupBox2});
			this.gbSigmoid.Location = new System.Drawing.Point(160, 8);
			this.gbSigmoid.Name = "gbSigmoid";
			this.gbSigmoid.Size = new System.Drawing.Size(440, 224);
			this.gbSigmoid.TabIndex = 11;
			this.gbSigmoid.TabStop = false;
			this.gbSigmoid.Text = "Sigmoid neuron";
			this.gbSigmoid.Visible = false;
			// 
			// label22
			// 
			this.label22.Location = new System.Drawing.Point(16, 184);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(192, 16);
			this.label22.TabIndex = 11;
			this.label22.Text = "temporary variables: input, tmp";
			// 
			// label21
			// 
			this.label21.Location = new System.Drawing.Point(16, 160);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(272, 23);
			this.label21.TabIndex = 10;
			this.label21.Text = "neuron parameters (properties): sigmo, force, inertia ";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(16, 136);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(168, 23);
			this.label20.TabIndex = 9;
			this.label20.Text = "internal variables: state, velocity";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(8, 104);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(56, 23);
			this.label15.TabIndex = 8;
			this.label15.Text = "inertia";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(8, 64);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(56, 16);
			this.label14.TabIndex = 7;
			this.label14.Text = "force";
			// 
			// lSigmo
			// 
			this.lSigmo.Location = new System.Drawing.Point(8, 24);
			this.lSigmo.Name = "lSigmo";
			this.lSigmo.Size = new System.Drawing.Size(56, 23);
			this.lSigmo.TabIndex = 6;
			this.lSigmo.Text = "sigmo";
			// 
			// tbInteria
			// 
			this.tbInteria.Location = new System.Drawing.Point(64, 104);
			this.tbInteria.Name = "tbInteria";
			this.tbInteria.Size = new System.Drawing.Size(72, 20);
			this.tbInteria.TabIndex = 5;
			this.tbInteria.Text = "";
			// 
			// tbForce
			// 
			this.tbForce.Location = new System.Drawing.Point(64, 64);
			this.tbForce.Name = "tbForce";
			this.tbForce.Size = new System.Drawing.Size(72, 20);
			this.tbForce.TabIndex = 4;
			this.tbForce.Text = "";
			// 
			// tbSigmo
			// 
			this.tbSigmo.Location = new System.Drawing.Point(64, 24);
			this.tbSigmo.Name = "tbSigmo";
			this.tbSigmo.Size = new System.Drawing.Size(72, 20);
			this.tbSigmo.TabIndex = 3;
			this.tbSigmo.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label19,
																					this.label18,
																					this.label17,
																					this.label16,
																					this.rbN,
																					this.rbNu});
			this.groupBox2.Location = new System.Drawing.Point(160, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(264, 112);
			this.groupBox2.TabIndex = 2;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Sigmoid type";
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(48, 82);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(184, 16);
			this.label19.TabIndex = 18;
			this.label19.Text = "else output = (1.0/(1.0+exp(-tmp)));";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(48, 66);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(128, 23);
			this.label18.TabIndex = 17;
			this.label18.Text = "if (tmp<-30.0) output = 0;";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(48, 34);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(200, 24);
			this.label17.TabIndex = 16;
			this.label17.Text = "else output = (2.0/(1.0+exp(-tmp))-1.0);";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(48, 18);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(136, 16);
			this.label16.TabIndex = 15;
			this.label16.Text = "if (tmp<-30.0) output = -1;";
			// 
			// rbN
			// 
			this.rbN.Checked = true;
			this.rbN.Location = new System.Drawing.Point(8, 18);
			this.rbN.Name = "rbN";
			this.rbN.Size = new System.Drawing.Size(32, 24);
			this.rbN.TabIndex = 1;
			this.rbN.TabStop = true;
			this.rbN.Text = "N";
			// 
			// rbNu
			// 
			this.rbNu.Location = new System.Drawing.Point(8, 66);
			this.rbNu.Name = "rbNu";
			this.rbNu.Size = new System.Drawing.Size(40, 24);
			this.rbNu.TabIndex = 0;
			this.rbNu.Text = "Nu";
			// 
			// gbDifferentiate
			// 
			this.gbDifferentiate.Controls.AddRange(new System.Windows.Forms.Control[] {
																						  this.label2,
																						  this.label3,
																						  this.tbDifPrevValue});
			this.gbDifferentiate.Location = new System.Drawing.Point(160, 8);
			this.gbDifferentiate.Name = "gbDifferentiate";
			this.gbDifferentiate.Size = new System.Drawing.Size(440, 224);
			this.gbDifferentiate.TabIndex = 12;
			this.gbDifferentiate.TabStop = false;
			this.gbDifferentiate.Text = "Differentiate neuron";
			this.gbDifferentiate.Visible = false;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(384, 23);
			this.label2.TabIndex = 6;
			this.label2.Text = "Calculate the difference between the current and the previous input values.";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(56, 80);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(112, 16);
			this.label3.TabIndex = 5;
			this.label3.Text = "Previous input value:";
			// 
			// tbDifPrevValue
			// 
			this.tbDifPrevValue.Enabled = false;
			this.tbDifPrevValue.Location = new System.Drawing.Point(176, 80);
			this.tbDifPrevValue.Name = "tbDifPrevValue";
			this.tbDifPrevValue.TabIndex = 4;
			this.tbDifPrevValue.Text = "1,0";
			// 
			// gbThreshold
			// 
			this.gbThreshold.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tbThreLo,
																					  this.tbThreHi,
																					  this.tbThrT,
																					  this.label7,
																					  this.label6,
																					  this.label5,
																					  this.label4});
			this.gbThreshold.Location = new System.Drawing.Point(160, 8);
			this.gbThreshold.Name = "gbThreshold";
			this.gbThreshold.Size = new System.Drawing.Size(440, 224);
			this.gbThreshold.TabIndex = 13;
			this.gbThreshold.TabStop = false;
			this.gbThreshold.Text = "Threshold neuron";
			this.gbThreshold.Visible = false;
			// 
			// tbThreLo
			// 
			this.tbThreLo.Location = new System.Drawing.Point(240, 160);
			this.tbThreLo.Name = "tbThreLo";
			this.tbThreLo.Size = new System.Drawing.Size(80, 20);
			this.tbThreLo.TabIndex = 14;
			this.tbThreLo.Text = "-1";
			// 
			// tbThreHi
			// 
			this.tbThreHi.Location = new System.Drawing.Point(240, 88);
			this.tbThreHi.Name = "tbThreHi";
			this.tbThreHi.Size = new System.Drawing.Size(80, 20);
			this.tbThreHi.TabIndex = 13;
			this.tbThreHi.Text = "1";
			// 
			// tbThrT
			// 
			this.tbThrT.Location = new System.Drawing.Point(104, 88);
			this.tbThrT.Name = "tbThrT";
			this.tbThrT.Size = new System.Drawing.Size(64, 20);
			this.tbThrT.TabIndex = 12;
			this.tbThrT.Text = "0";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(88, 88);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(16, 23);
			this.label7.TabIndex = 11;
			this.label7.Text = "t";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(208, 88);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(16, 23);
			this.label6.TabIndex = 10;
			this.label6.Text = "hi";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(208, 160);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(16, 23);
			this.label5.TabIndex = 9;
			this.label5.Text = "lo";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(392, 23);
			this.label4.TabIndex = 8;
			this.label4.Text = "Outputs lo if the input signal is below the t threshold. Outputs hi otherwise.";
			// 
			// buttonDefault
			// 
			this.buttonDefault.Location = new System.Drawing.Point(312, 248);
			this.buttonDefault.Name = "buttonDefault";
			this.buttonDefault.TabIndex = 12;
			this.buttonDefault.Text = "Default";
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(416, 248);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 11;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// buttonOk
			// 
			this.buttonOk.Location = new System.Drawing.Point(512, 248);
			this.buttonOk.Name = "buttonOk";
			this.buttonOk.TabIndex = 10;
			this.buttonOk.Text = "OK";
			this.buttonOk.Click += new System.EventHandler(this.buttonOk_Click);
			// 
			// gbConstant
			// 
			this.gbConstant.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.label1});
			this.gbConstant.Location = new System.Drawing.Point(160, 8);
			this.gbConstant.Name = "gbConstant";
			this.gbConstant.Size = new System.Drawing.Size(432, 224);
			this.gbConstant.TabIndex = 16;
			this.gbConstant.TabStop = false;
			this.gbConstant.Text = "Constant signal neron";
			this.gbConstant.Visible = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(104, 88);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(240, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "A neuron, which generates constant signal 1";
			// 
			// gbRandom
			// 
			this.gbRandom.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.label8});
			this.gbRandom.Location = new System.Drawing.Point(160, 8);
			this.gbRandom.Name = "gbRandom";
			this.gbRandom.Size = new System.Drawing.Size(440, 224);
			this.gbRandom.TabIndex = 17;
			this.gbRandom.TabStop = false;
			this.gbRandom.Text = "Random noise neuron";
			this.gbRandom.Visible = false;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(56, 80);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(348, 23);
			this.label8.TabIndex = 3;
			this.label8.Text = "Returns random values (uniform distribution) in the range of 1..+1";
			// 
			// cbOptimize
			// 
			this.cbOptimize.Location = new System.Drawing.Point(24, 248);
			this.cbOptimize.Name = "cbOptimize";
			this.cbOptimize.Size = new System.Drawing.Size(128, 24);
			this.cbOptimize.TabIndex = 18;
			this.cbOptimize.Text = "Optimize this neuron";
			// 
			// FormNeuronProperties
			// 
			this.AcceptButton = this.buttonOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(624, 302);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cbOptimize,
																		  this.groupBoxNeuronType,
																		  this.buttonOk,
																		  this.buttonCancel,
																		  this.buttonDefault,
																		  this.gbSigmoid,
																		  this.gbConstant,
																		  this.gbDifferentiate,
																		  this.gbRandom,
																		  this.gbThreshold,
																		  this.gbSinusoid});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormNeuronProperties";
			this.Text = "Neuron properties";
			this.Load += new System.EventHandler(this.FormNeuronProperties_Load);
			this.groupBoxNeuronType.ResumeLayout(false);
			this.gbSinusoid.ResumeLayout(false);
			this.gbSigmoid.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.gbDifferentiate.ResumeLayout(false);
			this.gbThreshold.ResumeLayout(false);
			this.gbConstant.ResumeLayout(false);
			this.gbRandom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private System.Windows.Forms.GroupBox groupBoxNeuronType;
		private System.Windows.Forms.RadioButton rbSigmoid;
		private System.Windows.Forms.RadioButton rbDifferentiate;
		private System.Windows.Forms.RadioButton rbThreshold;
		private System.Windows.Forms.RadioButton rbRandom;
		private System.Windows.Forms.RadioButton rbSinusoid;
		private System.Windows.Forms.GroupBox gbSinusoid;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.GroupBox gbSigmoid;
		private System.Windows.Forms.GroupBox gbDifferentiate;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbDifPrevValue;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox gbThreshold;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button buttonDefault;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Button buttonOk;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox gbConstant;
		private System.Windows.Forms.RadioButton rbConstant;
		private System.Windows.Forms.TextBox tbThreLo;
		private System.Windows.Forms.TextBox tbThreHi;
		private System.Windows.Forms.TextBox tbThrT;
		private System.Windows.Forms.TextBox tbt;
		private System.Windows.Forms.TextBox tbf0;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.RadioButton rbNu;
		private System.Windows.Forms.RadioButton rbN;
		private System.Windows.Forms.TextBox tbSigmo;
		private System.Windows.Forms.TextBox tbForce;
		private System.Windows.Forms.TextBox tbInteria;
		private System.Windows.Forms.Label lSigmo;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.GroupBox gbRandom;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.CheckBox cbOptimize;

		private Object neuron;

		private void panelSigmoid_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}

		private void rbSinusoid_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbSinusoid.Checked == true) gbSinusoid.Visible = true;
			else gbSinusoid.Visible = false;
		}

		private void rbRandom_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbRandom.Checked == true) gbRandom.Visible = true;
			else gbRandom.Visible = false;
		
		}

		private void rbSigmoid_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbSigmoid.Checked == true) 
			{
				tbForce.Text = Convert.ToString(0.04);
				tbInteria.Text = Convert.ToString(0.8);
				tbSigmo.Text = Convert.ToString(2);
				gbSigmoid.Visible = true;
			}
			else gbSigmoid.Visible = false;
		
		}

		private void rbThreshold_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbThreshold.Checked == true) gbThreshold.Visible = true;
			else gbThreshold.Visible = false;
		
		}

		private void rbDifferentiate_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbDifferentiate.Checked == true) gbDifferentiate.Visible = true;
			else gbDifferentiate.Visible = false;		
		}

		private void rbConstant_CheckedChanged(object sender, System.EventArgs e)
		{
			if (rbConstant.Checked == true) gbConstant.Visible = true;
			else gbConstant.Visible = false;				
		}

		private void FormNeuronProperties_Load(object sender, System.EventArgs e)
		{
		
		}

		private void buttonOk_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.OK;
			Point p = ((Neuron)neuron).point;
			double output = ((Neuron)neuron).output;
			Hashtable weights = ((Neuron)neuron).weights;
			if (rbDifferentiate.Checked == true)
				neuron =  new NeuronDifferentiate(p,Convert.ToDouble(tbDifPrevValue.Text),output,cbOptimize.Checked);
			else if (rbThreshold.Checked == true)
				neuron =  new NeuronThreshold(p,System.Convert.ToDouble(tbThrT.Text),System.Convert.ToDouble(tbThreHi.Text),System.Convert.ToDouble(tbThreLo.Text),output,cbOptimize.Checked);
			else if (rbConstant.Checked == true)
				neuron =  new NeuronConstant(p);
			else if (rbRandom.Checked == true)
				neuron =  new NeuronRandom(p,output,cbOptimize.Checked,new Random(601));
			else if (rbSigmoid.Checked == true)
			{
				if (rbN.Checked == true)					
                    neuron =  new NeuronSigmoidN(p,Convert.ToDouble(tbSigmo.Text),Convert.ToDouble(tbForce.Text),Convert.ToDouble(tbInteria.Text),output,cbOptimize.Checked);
				else 
					neuron =  new NeuronSigmoidNu(p,Convert.ToDouble(tbSigmo.Text),Convert.ToDouble(tbForce.Text),Convert.ToDouble(tbInteria.Text),output,cbOptimize.Checked);
					
			}
			else if (rbSinusoid.Checked == true)
				neuron =  new NeuronSinusoid(p, Convert.ToDouble(tbt.Text),Convert.ToDouble(tbf0.Text),output,cbOptimize.Checked);
			((Neuron)neuron).weights = weights;
			Close();
			return;
		}

		public Object getNeuron()
		{
			return neuron;
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();

		}

		private void gbRandom_Enter(object sender, System.EventArgs e)
		{
		
		}
	}
}
