using System;
using System.Drawing;
using System.Windows.Forms;

namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public class NeuronThreshold : NeuroX.Neuron
	{
		public NeuronThreshold(Point point,double t,double hi,double lo, double output, bool bOptimize)
		{
						this.bOptimize = bOptimize;
			this.t = t;
			this.hi = hi;
			this.output = output;
			this.lo = lo;
			this.point = new Point(point.X,point.Y);
			InitializeNeuron();
			myPen = new Pen(Color.Black, 2);
			drawBrush = new SolidBrush(Color.Black);
		}

		/// <summary>
		/// threeshold
		/// </summary>
		public double t;

		/// <summary>
		/// high signal
		/// </summary>
		public double hi;

		/// <summary>
		/// low signal
		/// </summary>
		public double lo;

		public override double CalculateOutput()
		{
			if (input < t) output = lo;
			else output = hi;
			return output;
		}
		public override void standardParam()
		{	
		
			t = 0;
			hi = 1;
			lo = -1;

		}
		public override void reset(Random r)
		{
	
		}
		public override void reset()
		{
	
		}
		public override void randomParam(Random r)
		{
			t = 0 + r.NextDouble()*(1);
		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
			g.DrawString("Thr",myFont,drawBrush,new Point(point.X,point.Y-15));
		}



	
		public override object Clone()
		{
			// TODO:  Add NeuronRandom.Clone implementation
			NeuronThreshold nt = new NeuronThreshold(point,t,hi,lo,output,bOptimize);
			Clone(nt);
			return nt;
		}
	}
}
